% Simulated Annealing low-autocorrelation program
% BSDLicence
% Rick van der Zwet - 0433373 - <hvdzwet@liacs.nl>

function [fitness,value] = sa(length, temperature, stopLimit)
    best_fitness = 0;
    s = initseq(length);
    stopCounter = 0;

    while (stopCounter < stopLimit)
        % Generate new mutation
        newseq = mutation(s);

        % Better is always accept
        fitness = autocorrelation(newseq);
        if (fitness > best_fitness)
            best_value = s;
            best_fitness = fitness;
            s = newseq;
            % disp(rot90(newseq,-1));
            stopCounter = 0;
        else
            % Make the next 'move' less atractive
            temperature =- 1;

            stopCounter =+ 1;
            % Accept on an certain probability
            if (temperature < 0)
                break;
            else 
                if(randint(0,temperature) > temperature / 4)
                    s = newseq;
               end
           end
       end
   end
    value = best_value;
    fitness = best_fitness;
end
